"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _button = _interopRequireDefault(require("../button"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('TextBox component', () => {
  afterEach(() => {
    (0, _react2.cleanup)();
  });
  describe('The Rendered HTML', () => {
    it('should have a label', () => {
      var {
        container
      } = (0, _react2.render)(_react.default.createElement(_button.default, null, "Save"));
      expect(container.firstChild).toMatchSnapshot();
    });
  });
  describe('handling event', () => {
    it('should set a value when passed in', () => {
      var mockHandler = jest.fn();
      var {
        container
      } = (0, _react2.render)(_react.default.createElement(_button.default, {
        onClick: mockHandler
      }, "Save"));
      expect(mockHandler.mock.calls.length).toBe(0);

      _react2.fireEvent.click(container.firstChild);

      expect(mockHandler.mock.calls.length).toBe(1);
    });
  });
});