"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _colorInput = _interopRequireDefault(require("../color-input"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('ColorInput component', () => {
  afterEach(() => {
    (0, _react2.cleanup)();
  });
  describe('The Rendered HTML', () => {
    it('should have a label', () => {
      var {
        getByText,
        container
      } = (0, _react2.render)(_react.default.createElement(_colorInput.default, {
        label: "My ColorInput Label"
      }));
      expect(container.firstChild).toMatchSnapshot();
      var label = getByText('My ColorInput Label');
      expect(label.textContent).toBe('My ColorInput Label');
    });
  });
  describe('handling input', () => {
    it('should set the value to `#000000` when passed non color input', () => {
      var {
        getByLabelText,
        container
      } = (0, _react2.render)(_react.default.createElement(_colorInput.default, {
        label: "My Color Value",
        initialValue: "#0668fa"
      }));
      expect(container.firstChild).toMatchSnapshot();
      var input = getByLabelText('My Color Value');
      expect(input.value).toBe('#0668fa');

      _react2.fireEvent.change(input, {
        target: {
          value: 'blue'
        }
      });

      expect(input.value).toBe('#000000');
    });
  });
});