"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _meter = _interopRequireDefault(require("../meter"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Meter component', () => {
  afterEach(() => {
    (0, _react2.cleanup)();
  });
  describe('The Rendered HTML', () => {
    it('should have a label', () => {
      var {
        getByText,
        container
      } = (0, _react2.render)(_react.default.createElement(_meter.default, {
        label: "My Meter Element",
        initialValue: 50
      }));
      expect(container.firstChild).toMatchSnapshot();
      var label = getByText('My Meter Element');
      expect(label.textContent).toBe('My Meter Element');
    });
  });
  describe('Element attributes', () => {
    it('should have a value set', () => {
      var {
        container
      } = (0, _react2.render)(_react.default.createElement(_meter.default, {
        label: "My Example Meter",
        initialValue: 50,
        max: 80
      }));
      expect(container.firstChild).toMatchSnapshot();
      var input = container.querySelector('meter');
      expect(input.getAttribute('value')).toBe('50');
      expect(input.getAttribute('max')).toBe('80');
    });
  });
});