"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _progress = _interopRequireDefault(require("../progress"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Progress component', () => {
  afterEach(() => {
    (0, _react2.cleanup)();
  });
  describe('The Rendered HTML', () => {
    it('should have a label', () => {
      var {
        getByText,
        container
      } = (0, _react2.render)(_react.default.createElement(_progress.default, {
        label: "My Progress Element",
        initialValue: 50
      }));
      expect(container.firstChild).toMatchSnapshot();
      var label = getByText('My Progress Element');
      expect(label.textContent).toBe('My Progress Element');
    });
  });
  describe('handling input', () => {
    it('should have a value set', () => {
      var {
        container
      } = (0, _react2.render)(_react.default.createElement(_progress.default, {
        label: "My Example Progress",
        initialValue: 20,
        max: 100
      }));
      expect(container.firstChild).toMatchSnapshot();
      var input = container.querySelector('progress');
      expect(input.getAttribute('value')).toBe('20');
    });
  });
});