"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _range = _interopRequireDefault(require("../range"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Range component', () => {
  afterEach(() => {
    (0, _react2.cleanup)();
  });
  describe('The Rendered HTML', () => {
    it('should have a label', () => {
      var {
        getByText,
        container
      } = (0, _react2.render)(_react.default.createElement(_range.default, {
        label: "My Range Label"
      }));
      expect(container.firstChild).toMatchSnapshot();
      var label = getByText('My Range Label');
      expect(label.textContent).toBe('My Range Label');
    });
  });
  describe('handling input', () => {
    it('should set a value when passed in', () => {
      var {
        getByLabelText,
        container
      } = (0, _react2.render)(_react.default.createElement(_range.default, {
        label: "My Label",
        initialValue: "23"
      }));
      expect(container.firstChild).toMatchSnapshot();
      var input = getByLabelText('My Label');
      expect(input.value).toBe('23');
    });
    it('should update a value when changed in', () => {
      var {
        getByLabelText,
        container
      } = (0, _react2.render)(_react.default.createElement(_range.default, {
        label: "My Label",
        initialValue: "23"
      }));
      expect(container.firstChild).toMatchSnapshot();
      var input = getByLabelText('My Label');

      _react2.fireEvent.change(input, {
        target: {
          value: 43
        }
      });

      expect(input.value).toBe('43');
    });
  });
});