"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _telephone = _interopRequireDefault(require("../telephone"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('Telephone component', () => {
  afterEach(() => {
    (0, _react2.cleanup)();
  });
  describe('The Rendered HTML', () => {
    it('should have a label', () => {
      var {
        getByText,
        container
      } = (0, _react2.render)(_react.default.createElement(_telephone.default, {
        label: "My Telephone Label"
      }));
      expect(container.firstChild).toMatchSnapshot();
      var label = getByText('My Telephone Label');
      expect(label.textContent).toBe('My Telephone Label');
    });
  });
  describe('handling input', () => {
    it('should set a value when passed in', () => {
      var {
        getByLabelText,
        container
      } = (0, _react2.render)(_react.default.createElement(_telephone.default, {
        label: "My Label",
        initialValue: "0800121212"
      }));
      expect(container.firstChild).toMatchSnapshot();
      var input = getByLabelText('My Label');
      expect(input.value).toBe('0800121212');
    });
  });
});