"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@testing-library/react");

var _urlInput = _interopRequireDefault(require("../url-input"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('UrlInput component', () => {
  afterEach(() => {
    (0, _react2.cleanup)();
  });
  describe('The Rendered HTML', () => {
    it('should have a label', () => {
      var {
        getByText,
        container
      } = (0, _react2.render)(_react.default.createElement(_urlInput.default, {
        label: "My UrlInput Label"
      }));
      expect(container.firstChild).toMatchSnapshot();
      var label = getByText('My UrlInput Label');
      expect(label.textContent).toBe('My UrlInput Label');
    });
  });
  describe('handling input', () => {
    it('should set a value when passed in but not be valid', () => {
      var {
        getByLabelText,
        container
      } = (0, _react2.render)(_react.default.createElement(_urlInput.default, {
        label: "My Example URL",
        initialValue: "http://www.example.com"
      }));
      expect(container.firstChild).toMatchSnapshot();
      var input = getByLabelText('My Example URL');
      expect(input.value).toBe('http://www.example.com');
      expect(input.validity.valid).toBe(true);

      _react2.fireEvent.change(input, {
        target: {
          value: 'Updated Value'
        }
      });

      expect(input.validity.valid).toBe(false);
    });
  });
});