"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useCheckedElement = _interopRequireDefault(require("../utils/use-checked-element"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * CheckBox Component.
 *
 */
var CheckBox = (0, _react.forwardRef)((_ref, ref) => {
  var {
    name,
    isChecked,
    label,
    value,
    className,
    labelClassName,
    inputClassName
  } = _ref,
      otherProps = _objectWithoutProperties(_ref, ["name", "isChecked", "label", "value", "className", "labelClassName", "inputClassName"]);

  var {
    id,
    checked,
    handleChange,
    inputRef
  } = (0, _useCheckedElement.default)(value, isChecked, ref);
  var labelStyleProp = labelClassName === '' ? {} : {
    className: labelClassName
  };
  var inputStyleProp = inputClassName === '' ? {} : {
    className: inputClassName
  };
  return _react.default.createElement("div", {
    className: (0, _classnames.default)("rfe-form__row", className)
  }, _react.default.createElement("label", _extends({
    htmlFor: id
  }, labelStyleProp), label || ''), _react.default.createElement("input", _extends({
    id: id,
    name: name,
    type: "checkbox"
  }, inputStyleProp, otherProps, {
    onChange: handleChange,
    value: value,
    checked: checked,
    ref: inputRef
  })));
});
CheckBox.displayName = 'ReactFormElements(CheckBox)';
CheckBox.propTypes = {
  /** The "label" for the element */
  label: _propTypes.default.string,

  /** The "value" for the element */
  value: _propTypes.default.string,

  /** If the checkbox should be checked */
  isChecked: _propTypes.default.bool,
  className: _propTypes.default.string,
  inputClassName: _propTypes.default.string,
  labelClassName: _propTypes.default.string
};
CheckBox.defaultProps = {
  label: 'label',
  isChecked: false,
  className: '',
  inputClassName: '',
  labelClassName: ''
};
var _default = CheckBox;
exports.default = _default;