"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useCheckedElement = _interopRequireDefault(require("./utils/use-checked-element"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Radio = (0, _react.forwardRef)((_ref, ref) => {
  var {
    name,
    isChecked,
    label,
    value
  } = _ref,
      otherProps = _objectWithoutProperties(_ref, ["name", "isChecked", "label", "value"]);

  var {
    id,
    checked,
    handleChange,
    inputRef
  } = (0, _useCheckedElement.default)(value, isChecked, ref);
  return _react.default.createElement("div", {
    className: "rfe-form__row"
  }, _react.default.createElement("label", {
    htmlFor: id
  }, label || ''), _react.default.createElement("input", _extends({
    id: id,
    name: name,
    type: "radio"
  }, otherProps, {
    onChange: handleChange,
    value: value,
    checked: checked,
    ref: inputRef
  })));
});
Radio.propTypes = {
  label: _propTypes.default.string,
  value: _propTypes.default.string,
  isChecked: _propTypes.default.bool
};
Radio.defaultProps = {
  label: 'label',
  isChecked: false
};
Radio.displayName = 'ReactFormElements(Radio)';
var _default = Radio;
exports.default = _default;