"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFormElement = _interopRequireDefault(require("../utils/use-form-element"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Range Component.
 *
 */
var Range = (0, _react.forwardRef)((_ref, ref) => {
  var {
    name,
    initialValue,
    label
  } = _ref,
      otherProps = _objectWithoutProperties(_ref, ["name", "initialValue", "label"]);

  var {
    id,
    value,
    handleChange,
    inputRef
  } = (0, _useFormElement.default)(initialValue, ref);
  return _react.default.createElement("div", {
    className: "rfe-form__row"
  }, _react.default.createElement("label", {
    htmlFor: id
  }, label || ''), _react.default.createElement("input", _extends({
    id: id,
    type: "range",
    onChange: handleChange,
    value: value,
    ref: inputRef
  }, otherProps)), _react.default.createElement("span", null, value));
});
Range.propTypes = {
  name: _propTypes.default.string,
  label: _propTypes.default.string,
  max: _propTypes.default.number,
  min: _propTypes.default.number,
  step: _propTypes.default.number
};
Range.defaultProps = {
  name: 'Range',
  initialValue: 50,
  label: 'label',
  max: 100,
  min: 0,
  step: 1
};
Range.displayName = 'ReactFormElements(Range)';
var _default = Range;
exports.default = _default;