"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formElementMapper = exports.childMapper = void 0;

var _react = require("react");

var childMapper = child => {
  var displayName = child.type ? child.type.displayName : false;
  if (!displayName) return child;
  return Object.assign({}, child, {
    ref: (0, _react.createRef)()
  });
};

exports.childMapper = childMapper;

var formElementMapper = (formEl, index) => ({
  name: formEl.props ? formEl.props.name : "".concat(formEl.name, "-").concat(index),
  ref: formEl.ref
});

exports.formElementMapper = formElementMapper;