"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _useId = _interopRequireDefault(require("./use-id"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var useCheckedElement = (value, initialChecked, ref) => {
  var id = (0, _useId.default)();
  var [checked, setChecked] = (0, _react.useState)(initialChecked);

  var handleChange = e => {
    setChecked(e.target.checked);
  };

  var inputRef = (0, _react.useRef)();
  (0, _react.useImperativeHandle)(ref, () => ({
    getValue: () => inputRef.current.checked ? value : null
  }));
  return {
    id,
    checked,
    inputRef,
    handleChange
  };
};

var _default = useCheckedElement;
exports.default = _default;